<template>
  <div class="main p-top-60 upload-section" :class="{ mobile: isMobileGlobal() }">
    <a-breadcrumb v-if="!isMobileGlobal()">
      <a-breadcrumb-item>
        <router-link to="/home">Home</router-link>
      </a-breadcrumb-item>
      <a-breadcrumb-item>Upload</a-breadcrumb-item>
    </a-breadcrumb>
    <h2 class="sub-title">Upload</h2>
    <a-row :gutter="16">
      <a-col :span="24" :md="{ span: 6 }">
        <a-upload
          name="avatar"
          list-type="picture-card"
          class="avatar-uploader"
          :show-upload-list="false"
          action="https://www.mocky.io/v2/5cc8019d300000980a055e76"
          :before-upload="beforeUpload"
          @change="handleChange"
        >
          <img v-if="imageUrl" :src="imageUrl" alt="avatar" />
          <div v-else>
            <a-icon :type="loading ? 'loading' : 'plus'" />
            <div class="ant-upload-text">
              Upload avatar
            </div>
          </div>
        </a-upload>
      </a-col>
      <a-col :span="24" :md="{ span: 18 }">
        <a-form :form="form" :layout="formLayout" @submit="handleSubmit">
          <a-row :gutter="16">
            <a-col :span="24" :md="{ span: 24 }">
              <div class="choose-file-upload">Choose file upload</div>
            </a-col>
            <a-col :span="24" :md="{ span: 12 }">
              <a-form-item label="Title">
                <a-input
                  placeholder=""
                  type="text"
                  v-decorator="['name', { rules: [{ required: true, message: 'Please input title!' }] }]"
                />
              </a-form-item>
              <a-form-item label="Genre">
                <a-input
                  placeholder=""
                  type="text"
                  v-decorator="['name', { rules: [{ required: true, message: 'Please input title!' }] }]"
                />
              </a-form-item>
              <a-form-item label="Kind of music">
                <!-- <a-checkbox style="color: #fff">
                    Albums
                </a-checkbox>
                <a-checkbox style="color: #fff">
                    Beat
                </a-checkbox>
                <a-checkbox style="color: #fff">
                    BGM
                </a-checkbox>
                <a-checkbox style="color: #fff">
                    All Sound
                </a-checkbox> -->
                <a-select default-value="album">
                  <a-select-option value="album">Albums</a-select-option>
                  <a-select-option value="beat">Beat</a-select-option>
                  <a-select-option value="bgm">BGM</a-select-option>
                  <a-select-option value="sound">All Sounds</a-select-option>
                </a-select>
              </a-form-item>
            </a-col>
            <a-col :span="24" :md="{ span: 12 }">
              <a-form-item label="Description">
                <a-textarea
                  :auto-size="{ minRows: 9, maxRows: 9 }"
                  placeholder=""
                  v-decorator="['email', { rules: [{ required: true, message: 'Please input genre!' }] }]"
                />
              </a-form-item>
            </a-col>

            <a-col :span="24" :md="{ span: 24 }">
              <a-row :gutter="16">
                <a-col :span="24" :md="{ span: 12 }">
                  <a-form-item label="Artist">
                    <a-input
                      placeholder=""
                      type="text"
                      v-decorator="[
                        'password',
                        {
                          rules: [
                            { required: true, message: 'Please input password!' },
                            { validator: validateToNextPassword }
                          ]
                        }
                      ]"
                    />
                  </a-form-item>
                  <a-form-item label="Composer">
                    <a-input
                      placeholder=""
                      type="text"
                      v-decorator="[
                        'password',
                        {
                          rules: [
                            { required: true, message: 'Please input password!' },
                            { validator: validateToNextPassword }
                          ]
                        }
                      ]"
                    />
                  </a-form-item>
                  <a-form-item label="Liricist">
                    <a-input
                      placeholder=""
                      type="text"
                      v-decorator="[
                        'password',
                        {
                          rules: [
                            { required: true, message: 'Please input password!' },
                            { validator: validateToNextPassword }
                          ]
                        }
                      ]"
                    />
                  </a-form-item>
                </a-col>
                <a-col :span="24" :md="{ span: 12 }">
                  <p style="color:#fff">Pricvacy:</p>
                  <a-checkbox style="color:#fff">
                    Public
                  </a-checkbox>
                  <p style="color:#fff">Lorem ipsum dolor sit amet consectetur adipisicing elit. Hic, laborum!</p>
                  <a-checkbox style="color:#fff">
                    Private
                  </a-checkbox>
                  <p style="color:#fff">Lorem ipsum dolor sit amet consectetur adipisicing elit. Hic, laborum!</p>
                </a-col>
              </a-row>
            </a-col>
            <a-col :span="24" :md="{ span: 12 }">
              <a-button class="upload-btn" html-type="submit">
                <a-icon type="arrow-up" />
                <span>Upload</span>
              </a-button>
            </a-col>
          </a-row>
        </a-form>
      </a-col>
    </a-row>
  </div>
</template>

<script>
function getBase64(img, callback) {
  const reader = new FileReader();
  reader.addEventListener("load", () => callback(reader.result));
  reader.readAsDataURL(img);
}

export default {
  data() {
    return {
      loading: false,
      imageUrl: "",
      formLayout: "vertical",
      form: this.$form.createForm(this, { name: "coordinated" }),
      confirmDirty: false
    };
  },
  methods: {
    handleChange(info) {
      this.loading = true;
      if (info.file.status === "uploading") {
        return;
      }
      if (info.file.status === "done") {
        // Get this url from response in real world.
        getBase64(info.file.originFileObj, (imageUrl) => {
          this.imageUrl = imageUrl;
          this.loading = false;
        });
        return;
      }
      if (info.file.status === "error") {
        getBase64(info.file.originFileObj, (imageUrl) => {
          this.imageUrl = imageUrl;
          this.loading = false;
        });
        return;
      }
    },
    beforeUpload(file) {
      const isJpgOrPng = file.type === "image/jpeg" || file.type === "image/png";
      if (!isJpgOrPng) {
        this.$message.error("You can only upload JPG file!");
      }
      const isLt2M = file.size / 1024 / 1024 < 2;
      if (!isLt2M) {
        this.$message.error("Image must smaller than 2MB!");
      }
      return isJpgOrPng && isLt2M;
    },
    handleSubmit(e) {
      e.preventDefault();
      this.form.validateFields((err, values) => {
        if (!err) {
          console.log("Received values of form: ", values);
        }
      });
    },
    handleConfirmBlur(e) {
      const value = e.target.value;
      this.confirmDirty = this.confirmDirty || !!value;
    },
    compareToFirstPassword(rule, value, callback) {
      const form = this.form;
      if (value && value !== form.getFieldValue("password")) {
        callback("Two passwords that you enter is inconsistent!");
      } else {
        callback();
      }
    },
    validateToNextPassword(rule, value, callback) {
      const form = this.form;
      if (value && this.confirmDirty) {
        form.validateFields(["confirm"], { force: true });
      }
      callback();
    }
  }
};
</script>

<style scoped>
.avatar-uploader > .ant-upload {
  width: 128px;
  height: 128px;
}

.ant-upload-select-picture-card i {
  font-size: 32px;
  color: #999;
}

.ant-upload-select-picture-card .ant-upload-text {
  margin-top: 8px;
  color: #666;
}

img {
  max-width: 100%;
}
.choose-file-upload,
.upload-btn {
  width: 100%;
  color: #fff;
  margin-bottom: 25px;
  padding: 15px;
  border-radius: 25px;
  text-align: center;
  cursor: pointer;
  background: #1db954;
  font-weight: 500;
  font-size: 16px;
  letter-spacing: -0.24px;
  color: #ffffff;
}
.upload-btn {
  outline: none;
  border: none;
  display: block;
  margin-bottom: 0;
  margin-top: 20px;
  height: unset;
}

* /deep/ .ant-upload {
  width: 100% !important;
  max-width: 320px;
  min-height: 200px;
}

/* Mobile Style */
.mobile {
  padding-top: 0;
}
.mobile .sub-title {
  font-weight: 500;
  font-size: 16px;
  letter-spacing: -0.24px;
  color: #ffffff;
  margin-bottom: 16px;
}
.mobile .avatar-uploader {
  display: flex;
  justify-content: center;
  margin-bottom: 22px;
}
.mobile textarea {
  min-height: 100px !important;
  max-height: 100px !important;
}
</style>
